// This may look like C code, but it is really -*- C++ -*-

//   Module      : AddressView.h   Version 1.6
//   LastSCCS    : 7/29/91  18:00:07
//   LastEdit    : "Wed Mar  6 15:59:16 1991"
//   Description : 
//   Author      : 
//   Copyright   : GMD Schloss Birlinghoven

#ifndef AddressView_h
#define AddressView_h

#include <Gina/GnObject.h>
#include <Gina/GnRowColumn.h>
#include <Gina/GnText.h>
#include <Gina/GnLabelG.h>

class Address;


class AddressView : public GnRowColumn {
  public:
    // Create a view for an Address
    AddressView(Address * = 0);
    
    // Display an Address in the view
    void Show(Address *);
    
    // Created an object from the view's contents (copies this->address)
    Address *Get();

    // Callbacks
    void add_value_changed_callback(GnCallback *);

    // New Resources
    void setR_editable(Boolean);
    Boolean getR_editable()
	{ return editable; };

    // Refine GnWidget::set_values()
    virtual void set_values();

  protected:
    // Display this->address in the view (only if widgets are created)
    void Update();

    void value_changed(caddr_t);
    
    virtual void before_create();
    virtual void after_create();
    
    GnText        last_name;
    GnLabelGadget last_name_text;
    GnText        first_names;
    GnLabelGadget first_names_text;
    GnText        street;
    GnLabelGadget street_text;
    GnText        house_number;
    GnLabelGadget house_number_text;
    GnText        city_code;
    GnLabelGadget city_code_text;
    GnText        city;
    GnLabelGadget city_text;
    GnText        local_area;
    GnLabelGadget local_area_text;
    GnText        country_code;
    GnLabelGadget country_code_text;
    GnText        telephone;
    GnLabelGadget telephone_text;
    GnText        email;
    GnLabelGadget email_text;
    GnText        creation_date;
    GnLabelGadget creation_date_label;
    GnText        last_modified;
    GnLabelGadget last_modified_label;

    Address   *address;
    Boolean    modified;
    GnCallback *value_changed_callback;
    Boolean    call_callbacks;
    Boolean    editable;
};

#endif AddressView_h
